﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Csla;
using Csla.Serialization;
using System.Data;
using System.Data.SqlClient;
using Csla.Data;

namespace Library.Rapport.Samling
{
    /// <summary>
    /// Liste med RapportKategori
    /// </summary>
    [Serializable]
    public class RapportKategoriList : ReadOnlyBindingListBase<RapportKategoriList, RapportKategoriInfo>
    {

        #region " Factory Methods "

        public static RapportKategoriList NewRapportKategoriList()
        {
            return new RapportKategoriList();
        }

        public static RapportKategoriList GetRapportKategoriList()
        {
            return DataPortal.Fetch<RapportKategoriList>();
        }

        #endregion


        #region " Data access "

        private void DataPortal_Fetch()
        {
            IsReadOnly = false;
            var item = DataPortal.FetchChild<RapportKategoriInfo>(1,1,1, "Uther", true);
            Add(item);
            item = DataPortal.FetchChild<RapportKategoriInfo>(2, 2, 2, "Arthur", true);
            Add(item);
            item = DataPortal.FetchChild<RapportKategoriInfo>(3, 3, 3, "Mordred", false);
            Add(item);
            item = DataPortal.FetchChild<RapportKategoriInfo>(4, 4, 4, "Gawain", true);
            Add(item);
            item = DataPortal.FetchChild<RapportKategoriInfo>(5, 5, 5, "Galahad", true);
            Add(item);
            IsReadOnly = true;
        }

        //private void DataPortal_Fetch()
        //{
        //    SearchObj SO;
        //    SO = GetSeekObjPrivate();
        //    SO.SearchFields.Item("RAKRec").FieldValueRange = SearchField.SOFieldValueRanges.FVR_Equal;
        //    SO.SearchFields.Item("RAKRec").FieldValue = RAKRec;
        //    FetchList(SO);
        //}

        //private void DataPortal_Fetch(SearchObj SO)
        //{
        //    FetchList(SO);
        //}

        //private void FetchList(SearchObj SO)
        //{
        //    IsReadOnly = false;
        //    //if (Convert.ToBoolean(SO.SearchFields.Item("VisIngenFrakt").FieldValue))
        //    //{
        //    //    Add(new RapportKategoriInfo() { RAKRec = 0, RAKNavn = "Ikke valgt" });
        //    //    Add(new RapportKategoriInfo() { RAKRec = -1, RAKNavn = "Ingen frakt" });
        //    //}
        //    using (var ctx = ConnectionManager<SqlConnection>.GetManager("Butikkdata"))
        //    {
        //        using (var cm = ctx.Connection.CreateCommand())
        //        {
        //            cm.CommandText = SO.SQL;
        //            cm.CommandType = System.Data.CommandType.Text;
        //            foreach (SQLParameter p in SO.SQLParameters)
        //            {
        //                cm.Parameters.AddWithValue("@" + p.Key, p.Value);
        //            }
        //            using (var dr = new SafeDataReader(cm.ExecuteReader()))
        //            {
        //                while (dr.Read())
        //                {
        //                    var item = DataPortal.FetchChild<RapportKategoriInfo>(dr);
        //                    Add(item);
        //                }
        //            }
        //        }
        //    }
        //    IsReadOnly = true;
        //}

        #endregion

    }
}


