﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using Wisej.Web;

namespace MGRptWebWisej.NetForms
{
    public class CursorKeeper : IDisposable
    {


        private Cursor _originalCursor;

        private bool _isDisposed = false;
        public CursorKeeper(Cursor newCursor)
        {
            _originalCursor = Application.Desktop.Cursor; //Wisej kan returnere bare null.
            Application.Desktop.Cursor = newCursor;
        }

        #region " IDisposable Support "

        protected virtual void Dispose(bool disposing)
        {
            if (!_isDisposed)
            {
                if (disposing)
                {
                    if(_originalCursor!=null)
                        Application.Desktop.Cursor = _originalCursor;
                    else
                        Application.Desktop.Cursor = Cursors.Default;
                }
            }
            _isDisposed = true;
        }

        public void Dispose()
        {
            // Do not change this code.  Put cleanup code in Dispose(ByVal disposing As Boolean) above.
            Dispose(true);
            GC.SuppressFinalize(this);
        }

        #endregion

    }
}